if not Recount and not EnsidiaFails then return end

local Recount = Recount
local fail = EnsidiaFails

RecountEnsidiaFails = LibStub("AceAddon-3.0"):NewAddon("RecountEnsidiaFails")
RecountEnsidiaFails.Version = tonumber(string.sub("$Revision: 01 $", 12, -3))

local RL = LibStub("AceLocale-3.0"):GetLocale("Recount")
local L = LibStub("AceLocale-3.0"):GetLocale("LibFail-2.0")

local lf = LibStub("LibFail-2.0")

local failEvents = lf:GetSupportedEvents()

-------------------------------------------------------------------------
-- LOCALES
-------------------------------------------------------------------------

local DetailTitles = {}
DetailTitles.FailedHow={
	TopNames = RL["Ability Name"],
	TopCount = "",
	TopAmount = RL["Count"],
	BotNames = "",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = RL["Count"]
}

local function onFail(event, who)
	if not Recount.db2.combatants[who] then
		Recount:DPrint("No source combatant!")
	else
		local sourceData = Recount.db2.combatants[who]
		local sourceName = sourceData.Name
		Recount:AddAmount(sourceData, "EnsidiaFails", 1)
		local name = lf:GetEventName(event) or ""
		Recount:AddTableDataStats(sourceData, "FailedHow", name, sourceName, 1)
	end
end

for _, event in ipairs(failEvents) do
	fail.RegisterCallback("RecountEnsidiaFails", event, onFail)
end

function RecountEnsidiaFails:DataModesFailBot(data, num)
	if not data then return 0 end
	if num==1 then
		return (data.Fights[Recount.db.profile.CurDataSet].EnsidiaFails or 0)
	else
		return (data.Fights[Recount.db.profile.CurDataSet].EnsidiaFails or 0), {{data.Fights[Recount.db.profile.CurDataSet].FailedHow, L["'s Fail Events"], DetailTitles.FailedHow}}
	end
end

function RecountEnsidiaFails:TooltipFuncsFailBot(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData(RL["Top 3"].." "..L["Fails"],data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet].FailedHow, 3)
	GameTooltip:AddLine("<"..RL["Click for more Details"]..">", 0, 0.9, 0)
end

Recount:AddModeTooltip("EnsidiaFails", RecountEnsidiaFails.DataModesFailBot, RecountEnsidiaFails.TooltipFuncsFailBot, nil, nil, nil, nil)
